package nc.bs.xh.servlet;
import java.io.IOException;
import java.lang.reflect.Method;
import java.util.Map;
import java.io.PrintWriter;
import java.io.StringWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.sf.json.JSONObject;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.bs.servlet.service.BaseServlet;
import nc.impl.xh.report.inoutledger.InFactorDelegator;
import nc.impl.xh.report.inoutledger.PathService;
import nc.log.NcLog;

/**
 * 
 * ҵ񵥾ɾӿ
 * @author ZTH
 *
 */
public class XhDeleteApiServlet extends BaseServlet implements IHttpServletAdaptor{
	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp)
			                                             throws ServletException, IOException {
		try {
			String createStr = buildJson(req, resp, this.getClass().getName());
			JSONObject json = JSONObject.fromObject(createStr);
			NcLog.info("json:"+json);
			String datatype=json.getString("datatype");	//	
			ISecurityTokenCallback sc = (ISecurityTokenCallback)NCLocator.getInstance().lookup(
				    ISecurityTokenCallback.class);
			sc.token("NCSystem".getBytes(),"pfxx".getBytes());
			
			//InFactorDelegator infdor=new InFactorDelegator();
			//Map<String,String> map=infdor.initDataBase();
			//String methodName=map.get(datatype);
			String methodName = PathService.GetPath(datatype);
			String className = "nc.impl.xh.api.DeltBusnesDcmentsImpl";
			Class clz = Class.forName(className);
			Object obj = clz.newInstance();	
			Method m =obj.getClass().getDeclaredMethod(methodName,JSONObject.class);//ƻȡ
			String vbillcode=(String) m.invoke(obj, json);		
			resp.getWriter().write(formatRSJsonData("ɹ","",vbillcode).toString());
			
		} catch (Exception e) {
			StringWriter stringWriter = new StringWriter();
			e.printStackTrace(new PrintWriter(stringWriter));
			//ȡϸϢ
			String msg=stringWriter.getBuffer().toString();
			NcLog.info("ӿڷֵʾ:"+msg);
			//ǰ˿̨ӡxml
			resp.getWriter().write(formatRSJsonData("ʧ",
					e.getCause().getMessage()==null?e.getCause().toString():e.getCause().getMessage(),"").toString());
			
		}
		
	}

}
